#include <iostream> 

class TClassA
{
	int a;
	int x;
public:
	TClassA(){};
	TClassA(int x_):x(x_){};
  	void Display(const char* text) { std::cout << text <<"..."<< x <<'\n'; };
    static void Wrapper_To_Call_Display(void* pt2Object, char* text);
};

class TClassB
{
	int b;
  	int x;
public:
  	TClassB(){};
	TClassB(int x_):x(x_){};  
  	void Display(const char* text) { std::cout << text <<"..."<< x <<'\n'; };
    template<class T> static void Wrapper_To_Call_Display(T* pt2Object, char* text);
};
   
template<class T> void TClassB::Wrapper_To_Call_Display(T* pt2Object, char* string)
{
	pt2Object->Display(string);
}     
   
template<class T> void DoItB(T* pt2Object, void (*pt2Function)(T* pt2Object, char* text))
{
	pt2Function(pt2Object, "Hello, I'm TEMPLATE-callback using a argument");
}   
     
void Callback_Using_Argument()
{
	TClassA objA;
	TClassB objB(456);  
  	int b=0;
     
  	DoItB(&objB, &TClassB::Wrapper_To_Call_Display);//it's Ok
  	DoItB(&objA, &TClassB::Wrapper_To_Call_Display);//it's Ok too 
  
/*
	If the following function will be uncommented the Compiler will say: 
	-- exampleB.cpp: In function `static void TClassB::Wrapper_To_Call_Display<int>(int *, char *)':
	-- exampleB.cpp:50:   instantiated from here
	-- exampleB.cpp:27: request for member `Display' in `*pt2Object', which is of non-aggregate type `int'
*/   
////	DoItB(&b, &TClassB::Wrapper_To_Call_Display);//error 
     
}
   
int main()
{
   	Callback_Using_Argument();
   	return 0;
}
